_G.CO_MS_CookFaster = _G.CO_MS_CookFaster or {}
CO_MS_CookFaster.options_menu = "CO_MS_CookFaster_menu"
CO_MS_CookFaster.ModPath = ModPath
CO_MS_CookFaster.SaveFile = CO_MS_CookFaster.SaveFile or SavePath .. "CO_MS_CookFaster.txt"
CO_MS_CookFaster.ModOptions = CO_MS_CookFaster.ModPath .. "menus/modoptions.txt"
CO_MS_CookFaster.settings = CO_MS_CookFaster.settings or {}

function CO_MS_CookFaster:Reset()
	self.settings = {
		Delay = 2,
		Bile_Coming = true,
	}
	self:Save()
end

function CO_MS_CookFaster:Load()
	local file = io.open(self.SaveFile, "r")
	if file then
		for key, value in pairs(json.decode(file:read("*all"))) do
			self.settings[key] = value
		end
		file:close()
	else
		self:Reset()
	end
end

function CO_MS_CookFaster:Save()
	local file = io.open(self.SaveFile, "w+")
	if file then
		file:write(json.encode(self.settings))
		file:close()
	end
end

CO_MS_CookFaster:Load()

Hooks:Add("LocalizationManagerPostInit", "CO_MS_CookFaster_loc", function(loc)
	LocalizationManager:add_localized_strings({
		["CO_MS_CookFaster_menu_title"] = "Cook Faster for Cook Off: Meth Slaves",
		["CO_MS_CookFaster_menu_desc"] = "",
		["CO_MS_CookFaster_menu_Delay_title"] = "Time for Next Thing",
		["CO_MS_CookFaster_menu_Delay_desc"] = "",
		["CO_MS_CookFaster_menu_Bile_Coming_title"] = "Faster Bile",
		["CO_MS_CookFaster_menu_Bile_Coming_desc"] = "",
	})
end)

Hooks:Add("MenuManagerSetupCustomMenus", "CO_MS_CookFasterOptions", function( menu_manager, nodes )
	MenuHelper:NewMenu( CO_MS_CookFaster.options_menu )
end)

Hooks:Add("MenuManagerPopulateCustomMenus", "CO_MS_CookFasterOptions", function( menu_manager, nodes )
	MenuCallbackHandler.CO_MS_CookFaster_menu_Delay_callback = function(self, item)
		CO_MS_CookFaster.settings.Delay = math.floor(item:value())
		CO_MS_CookFaster:Save()
	end
	MenuHelper:AddSlider({
		id = "CO_MS_CookFaster_menu_Delay_callback",
		title = "CO_MS_CookFaster_menu_Delay_title",
		callback = "CO_MS_CookFaster_menu_Delay_callback",
		value = CO_MS_CookFaster.settings.Delay,
		min = 1,
		max = 45,
		step = 1,
		show_value = true,
		menu_id = CO_MS_CookFaster.options_menu,  
	})
	MenuCallbackHandler.CO_MS_CookFaster_menu_Bile_Coming_callback = function(self, item)
		CO_MS_CookFaster.settings.Bile_Coming = item:value() == "on" and true or false
		CO_MS_CookFaster:Save()
	end
	MenuHelper:AddToggle({
		id = "CO_MS_CookFaster_menu_Bile_Coming_callback",
		title = "CO_MS_CookFaster_menu_Bile_Coming_title",
		callback = "CO_MS_CookFaster_menu_Bile_Coming_callback",
		value = CO_MS_CookFaster.settings.Bile_Coming,
		menu_id = CO_MS_CookFaster.options_menu,
	})
end)

Hooks:Add("MenuManagerBuildCustomMenus", "CO_MS_CookFasterOptions", function(menu_manager, nodes)
	nodes[CO_MS_CookFaster.options_menu] = MenuHelper:BuildMenu( CO_MS_CookFaster.options_menu )
	MenuHelper:AddMenuItem(nodes["blt_options"], CO_MS_CookFaster.options_menu, "CO_MS_CookFaster_menu_title", "CO_MS_CookFaster_menu_desc")
end)
